<template>
  <div
    class="c88d-entry mb-10"
    :variant="currentPath"
    :style="[
      totalLines > 1 ? `margin-bottom: calc(3rem * ${totalLines})` : '',
      `background-image: url('${getBackgroundImage()}');`,
    ]"
  >
    <template v-if="games.length > 0">
      <div class="c88d-entry__left">
        <img
          ref="leftImage"
          class="c88d-entry__image fadeIn"
          :src="activeBtn ? getLeftImage(activeBtn) : ''"
          @load="handleLoad"
          @error="handleError"
        />
      </div>
      <div class="c88d-entry__right">
        <div class="c88d-entry__content-container">
          <div class="c88d-entry__logo-container">
            <img
              ref="rightLogo"
              class="c88d-entry__logo"
              :src="
                activeBtn ? getProviderLogo(activeBtn.GameProviderName) : ''
              "
              @load="handleLoad"
              @error="handleError"
            />
          </div>
          <p
            v-if="currentPath === 'virtual_sports'"
            class="c88d-entry__content-title"
          >
            {{ $t("virtual_sports") }}
          </p>
          <p class="c88d-entry__content-text" v-if="!$t(games[currentIndex].IntroForDisplay.short).includes('_')">{{ $t(games[currentIndex].IntroForDisplay.short) }}</p>
          <div @click="() => onClickPlayGame(Number(activeBtn?.GameId), isAuthenticated, String(activeBtn?.TabType), EnumEntranceLocation.GameLobby)"
            class="c88d-entry__btn"
          >
            {{ $t("bet_now") }}
          </div>
        </div>
      </div>
      <div class="c88d-entry__buttons-container">
        <div class="c88d-entry__buttons" :overflow="totalLines > 1">
          <c88d-button
            v-for="(game, index) in games"
            :key="index"
            :is-active="activeBtn ? activeBtn.GameId === game.GameId : false"
            :logo="getProviderLogo(game.GameProviderName)"
            :is-hot="game.IsHotGame"
            :is-new="game.IsNewGame"
            :is-multiple-provider="providerCount[game.GameProviderName] > 1"
            :title="game.EnglishGameName"
            :text="game.GameName"
            @click="handleSelectGame(game, index)"
          />
        </div>
      </div>
    </template>
    <no-game-message v-else />
  </div>
</template>

<script setup lang="ts">
import _ from "lodash";
import { useRoute } from "vue-router";
import { ref, computed, watch } from "vue";
import C88dButton from "./C88dButton.client.vue";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import textHelper from "@/utils/formatHelpers/textFormatHelper";
import NoGameMessage from "@/components/lobby/no-game-message.client.vue";

const props = defineProps({
  games: {
    type: Array as PropType<Array<GameBsi>>,
    required: true,
  },
  tagLine: {
    type: String,
    required: false,
    default: "",
  },
});
const providerCount = textHelper.checkMultiple(props.games);

const route = useRoute();
const { convertString } = textHelper;
const { getAssetImage, onClickPlayGame } = commonHelper;

const activeBtn = ref<GameBsi | undefined>(_.first(props.games));
const leftImage = ref<Element | undefined>();
const rightLogo = ref<Element | undefined>();
const currentPath = computed(() =>
  route.path.replace("/", "").replaceAll("-", "_").trim().toLowerCase()
);
const isAuthenticated = computed(() => store.state.auth);
const totalLines = computed(() => {
  const totalGames = props.games.length;
  const gamesPerLine = 8;
  const total = totalGames / gamesPerLine;
  if (total <= 1) return 1;
  return Math.ceil(total);
});

const getProviderLogo = (providerName: string): string => {
  try {
    const fileName = `provider_logo_${convertString(providerName, true)}.png`;
    return getAssetImage(
      `assets/theme/cool_88/desktop/logos/providers/${fileName}`
    );
  } catch (error) {
    return "";
  }
};
const getLeftImage = (game: GameBsi): string => {
  try {
    let fileName = `banner_${currentPath.value}_${convertString(
      game.GameProviderName,
      true
    )}.png`;
    if (game.GameProviderId === 1052) {
      fileName = `banner_${currentPath.value}_${convertString(
        game.GameProviderName,
        true
      )}new.png`;
    }
    if (currentPath.value === "virtual_sports") {
      fileName = `banner_${currentPath.value}_${convertString(
        game.EnglishGameName,
        true
      )}.png`;
    }
    return getAssetImage(`assets/theme/cool_88/desktop/banners/${fileName}`);
  } catch (error) {
    return "";
  }
};
const getBackgroundImage = (): string => {
  try {
    const fileName = `banner_${currentPath.value}_background.png`;
    return getAssetImage(`assets/theme/cool_88/desktop/banners/${fileName}`);
  } catch (error) {
    return "";
  }
};
const currentIndex = ref(0);
const handleSelectGame = (game: GameBsi, currIndex: number): void => {
  activeBtn.value = game;
  currentIndex.value = currIndex;
};
const handleError = (e: Event): void => {
  if (!e.currentTarget) return;
  // @ts-ignore
  e.currentTarget.style.display = "none";
};
const handleLoad = (e: Event): void => {
  if (!e.currentTarget) return;
  // @ts-ignore
  e.currentTarget.style.display = "block";
};
/**
 * animates an element by adding and removing fadeIn class after a set duration
 * @param {element} element element to animate
 * @param {number} duration time to remove class in seconds
 */
const animateFadeIn = (
  element: Element | null | undefined,
  duration = 0.4
): void => {
  if (!element) return;
  element.classList.add("fadeIn");
  setTimeout(() => {
    element.classList.remove("fadeIn");
  }, duration * 1000);
};
const handleActiveBtnChange = async (): Promise<void> => {
  if (!activeBtn.value) return;

  if (leftImage.value) {
    animateFadeIn(leftImage.value);
  }
  if (rightLogo.value) {
    animateFadeIn(rightLogo.value);
  }
};

const setedLogo = ref<Array<string>>([]);
const isExistLogo = (logo: string, index: number): boolean => {
  if (index === 0) {
    setedLogo.value = [];
  }
  if (setedLogo.value.includes(logo)) {
    return true;
  }
  setedLogo.value.push(logo);
  return false;
};

watch(() => activeBtn.value, handleActiveBtnChange);
</script>

<style scoped>
@keyframes fadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
.no-game-message {
  color: var(--text5);
}
.c88d-entry {
  aspect-ratio: 3.125;
  width: 100%;
  max-height: 460px;
  height: 100%;
  background-repeat: no-repeat;
  background-position: center;
  background-size: 100% 460px;
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
}
.c88d-entry::before {
  content: "";
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  background: linear-gradient(
    90deg,
    rgb(0 0 0) 0%,
    rgba(255, 255, 255, 0) 31.77%,
    rgba(255, 255, 255, 0) 67.71%,
    rgb(0 0 0) 100%
  );
}
.c88d-entry::after {
  content: "";
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  height: 15%;
  background: linear-gradient(0deg, rgb(25 25 25) 28%, rgb(0 0 0 / 0) 100%);
}
.c88d-entry__left,
.c88d-entry__right {
  max-height: 100%;
  height: 100%;
  position: relative;
}
.c88d-entry__left {
  width: 100%;
  display: flex;
  align-items: flex-end;
  justify-content: flex-end;
}
.c88d-entry__right {
  width: 100%;
  background: rgba(0, 0, 0, 0.5);
  clip-path: polygon(15% 0%, 100% 0%, 100% 100%, 0% 100%);
}
.c88d-entry__image {
  height: 100%;
  object-fit: contain;
}
.c88d-entry__right::before {
  content: "";
  position: absolute;
  left: 0;
  top: 0;
  height: 100%;
  width: 100%;
  background: linear-gradient(
    189.39deg,
    #b07515 0.64%,
    #f5d77f 22.14%,
    #ffffd7 41.59%,
    #f5d77f 61.04%,
    #b07515 78.96%,
    #f5d77f 98.41%
  );
  clip-path: polygon(15% 0%, 16% 0, 1% 100%, 0% 100%);
}
.c88d-entry[variant="virtual_sports"] .c88d-entry__right {
  width: 70%;
  background: transparent;
  clip-path: unset;
}
.c88d-entry[variant="virtual_sports"] .c88d-entry__right::before {
  display: none;
}
.c88d-entry[variant="virtual_sports"] .c88d-entry__content-container {
  margin-left: unset;
}
.c88d-entry__content-container {
  max-width: 336px;
  width: 100%;
  height: 100%;
  margin-left: 16%;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  gap: 10px;
}
.c88d-entry__logo-container {
  aspect-ratio: 2.5;
  max-width: 240px;
  width: 100%;
  display: flex;
  align-items: center;
  overflow: hidden;
}
.c88d-entry__logo {
  width: 100%;
  height: 100%;
  object-fit: contain;
}
.fadeIn {
  animation: fadeIn 0.4s ease-in-out forwards;
}
.c88d-entry__content-text {
  padding: 0 0.25rem;
  text-align: center;
  color: var(--text5);
}
.c88d-entry__btn {
  aspect-ratio: 4.25;
  max-width: 136px;
  width: 100%;
  background: var(--primary);
  border-radius: 4px;
  color: var(--textBtn);
  font-size: 12px;
  line-height: 14px;
  font-weight: 700;
  display: flex;
  align-items: center;
  justify-content: center;
}
.c88d-entry__buttons-container {
  position: absolute;
  width: 100%;
  height: max-content;
  top: 85%;
  left: 0;
  z-index: 4;
  display: flex;
  justify-content: center;
}
.c88d-entry__buttons {
  position: relative;
  max-width: 1200px;
  width: 100%;
  gap: 16px 8px;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-wrap: wrap;
}
.c88d-entry__buttons[overflow="true"] {
  justify-content: start;
}
.c88d-entry__content-title {
  font-weight: 700;
  font-size: 36px;
  line-height: 42px;
  text-align: center;
  text-transform: uppercase;
  color: var(--secondary);
}
</style>
